"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Visitor = require("./Visitor");

var _Visitor2 = _interopRequireDefault(_Visitor);

var _FileUtility = require("../util/FileUtility");

var _FileUtility2 = _interopRequireDefault(_FileUtility);

var _ReactTransformer = require("../docs/react/ReactTransformer");

var _ReactTransformer2 = _interopRequireDefault(_ReactTransformer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Transformer = function () {
    function Transformer(root, configFilePath) {
        var _this = this;

        _classCallCheck(this, Transformer);

        this.pre = function (source) {
            if (!_this.root) {
                _this.__init(source.opts.sourceRoot, ".doc.gen.json");
            }

            var fileInformation = _FileUtility2.default.getInformation(source.opts.filename);

            if (_this.reactTransformer) {
                _this.reactTransformer.transform(fileInformation, source.code);
            }
        };

        if (root) {
            if (!configFilePath) {
                configFilePath = ".doc.gen.json";
            }
            this.__init(root, configFilePath);
        }
    }

    _createClass(Transformer, [{
        key: "__init",
        value: function __init(root, configFilePath) {
            if (!this.root) {
                this.root = root;
                var configSource = _FileUtility2.default.readFile(this.root + "/" + configFilePath);
                this.config = JSON.parse(configSource);
                if (this.config.react) {
                    this.config.react.root = this.root;
                    this.reactTransformer = new _ReactTransformer2.default(this.config.react);
                }
            }
        }
    }]);

    return Transformer;
}();

exports.default = Transformer;